// Copyright 2002 Isildur, all rights reserved
//
// email: v_d_d@yahoo.com
// web: http://www.geocities.com/v_d_d
//
//////////////////////////////////////////////

//////////////////////////////////////////////
//
// Shows a DLL that can be injected in another
// process. This example modifies Notepad.
// See tutorial for more details.
//
//////////////////////////////////////////////

#include <windows.h>
#include <windowsx.h>

#include "inject.h"


// start shared data between processes
#pragma data_seg("Shared")
HHOOK g_hook = NULL;
DWORD g_threadID = 0;
HWND  g_hwnd = 0;
#pragma data_seg()
// end shared data

// tell linker to make section readable, writable and shared
#pragma comment(linker, "/section:Shared,rws")


///////////////////////////////////////
HINSTANCE g_dll;
WNDPROC OldProc;
HWND g_hwndEdit;

COLORREF g_backColor = RGB(255,255,255);
COLORREF g_textColor = RGB(0,0,0);
HBRUSH g_bgBrush = 0;

BOOL WINAPI DllMain(HINSTANCE hDLLInst, DWORD fdwReason, LPVOID lpvReserved)
{

    switch (fdwReason)
    {
        case DLL_PROCESS_ATTACH:
        {
			// save the dll's instance
			g_dll = hDLLInst;
		}
        break;

        case DLL_PROCESS_DETACH:
		{    
		
		}
        break;

        case DLL_THREAD_ATTACH:
		{

		}
        break;
        
		case DLL_THREAD_DETACH:
		{

		}
        break;
    }
    return TRUE;
}


// threadID is the thread you want to hook to
// the hwnd should be the thread's main window
int WINAPI SetHook(DWORD threadID, HWND hwnd)
{

	if(!threadID)
		return 0;

	// make sure there is not already a hook
	if(g_hook)
	{
		UnhookWindowsHookEx(g_hook);
		g_hook = NULL;
	}

	// save the window handle
	g_hwnd = hwnd;

	// set hook
	g_hook = SetWindowsHookEx(WH_GETMESSAGE, GetMsgProc, g_dll, threadID);

	if(!g_hook)
	{
		return 0;
	}

	// save the caller's thread id, can be usefull
	// to send a message back
	g_threadID = GetCurrentThreadId();
	
	// forces the remote process to call our GetMsgProc
	// and map our dll in it's memory space
	PostThreadMessage(threadID, WM_NULL, 0, 0);

	return 1;

}

void WINAPI UnsetHook()
{
	if(g_hook)
	{
		UnhookWindowsHookEx(g_hook);
		g_hook = NULL;
	}
}

// our main entrance in the remote process's memory space
LRESULT WINAPI GetMsgProc(int nCode, WPARAM wParam, LPARAM lParam)
{
	static BOOL firstTime = TRUE;

	// do this only the first time
	if(firstTime)
	{
		firstTime = FALSE;

		// subclass the main window of our target
		OldProc = (WNDPROC) SetWindowLong(g_hwnd, GWL_WNDPROC, (LONG) DLLNewProc);

		// get the window handle of Notepad's edit box
		g_hwndEdit = FindWindowEx(g_hwnd, NULL,"Edit",NULL);

		// load our new menu items
		createAndLoadMenuItems();
	}

	return(CallNextHookEx(g_hook, nCode, wParam, lParam));
}


// this is the subclass message proc
// here we intercept all messages sent to the target's main window
LRESULT CALLBACK DLLNewProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
     switch (message)
     {
		case WM_COMMAND:
		{
			switch(LOWORD(wParam)) 
			{
				// menu for setting bg color
				case 57602:
				{
					static CHOOSECOLOR cc ;
					static COLORREF    crCustColors[16] ;
					BOOL result;

					 cc.lStructSize    = sizeof (CHOOSECOLOR) ;
					 cc.hwndOwner      = NULL ;
					 cc.hInstance      = NULL ;
					 cc.rgbResult      = g_backColor;
					 cc.lpCustColors   = crCustColors ;
					 cc.Flags          = CC_RGBINIT | CC_FULLOPEN ;
					 cc.lCustData      = 0 ;
					 cc.lpfnHook       = NULL ;
					 cc.lpTemplateName = NULL ;

					 result = ChooseColor (&cc);

					 if(result)
					 {
						 if(g_bgBrush)
						 {
							DeleteObject(g_bgBrush);
							g_bgBrush = 0;
						 }

						 g_backColor = cc.rgbResult;

						 g_bgBrush = CreateSolidBrush(g_backColor);

						 InvalidateRect(g_hwndEdit, NULL, 1);
					 }
				}
				break;

				// menu for setting text color
				case 57603:
				{
					static CHOOSECOLOR cc ;
					static COLORREF    crCustColors[16] ;
					BOOL result;

					 cc.lStructSize    = sizeof (CHOOSECOLOR) ;
					 cc.hwndOwner      = NULL ;
					 cc.hInstance      = NULL ;
					 cc.rgbResult      = g_textColor;
					 cc.lpCustColors   = crCustColors ;
					 cc.Flags          = CC_RGBINIT | CC_FULLOPEN ;
					 cc.lCustData      = 0 ;
					 cc.lpfnHook       = NULL ;
					 cc.lpTemplateName = NULL ;

					 result = ChooseColor (&cc);

					 if(result)
					 {
						 g_textColor = cc.rgbResult;

						 InvalidateRect(g_hwndEdit, NULL, 1);
					 }
				}
				break;
			}
		}
		break;

		case WM_CTLCOLOREDIT:
		{
			// message we get when the app wants to draw the edit control
			if(!g_bgBrush)
			{
				g_bgBrush = CreateSolidBrush(g_backColor);	
			}

			SetBkColor((HDC) wParam, g_backColor);
			SetTextColor((HDC) wParam, g_textColor);	
			
			return (LRESULT)g_bgBrush;
		}
		break;

		case WM_DESTROY:
		{
			// clean up
			if(g_bgBrush)
			{
				DeleteObject(g_bgBrush);
			}
		}
		break;
     }
     return CallWindowProc(OldProc, hwnd, message, wParam, lParam);
}

int createAndLoadMenuItems()
{
	HMENU mainMenu, subMenu;

	mainMenu = GetMenu(g_hwnd);
	subMenu = GetSubMenu(mainMenu, 2);

	AppendMenu(subMenu, MF_SEPARATOR, 0, NULL);
	AppendMenu(subMenu, MF_STRING, 57602, "Set background color...");
	AppendMenu(subMenu, MF_STRING, 57603, "Set text color...");

	return 1;
}

